Bug 18952 - Sec. 7.1 Hidden Content still lacks a specified mechanism to enable user agents to programmatically distinguish two conflicting use cases
Summary: Sec. 7.1 Hidden Content still lacks a specified mechanism to enable user agen...
Status: RESOLVED FIXED
Alias: None
Product: HTML WG
Classification: Unclassified
Component: HTML5 spec (show other bugs)
Version: unspecified
Hardware: All All
: P2 major
Target Milestone: ---
Assignee: Edward O'Connor
QA Contact: HTML WG Bugzilla archive list
URL:
Whiteboard:
Keywords: a11y
Depends on:
Blocks:
 
Reported: 2012-09-21 15:43 UTC by Janina Sajka
Modified: 2012-09-26 15:23 UTC (History)
8 users (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Janina Sajka 2012-09-21 15:43:25 UTC
We have two incompatible use cases: 1.) where authors mark content hidden because itś not yet ready for use, or because itś inappropriate to the current user context; and 2.) where itś available for users to read if they perform some command to ask to see that content. In the former authors need the confidence that users will not view that hidden content. In the latter authors need to know that users will be informed that additional content is available and that they will be allowed to view it. Therefore, we need markup consistent across all user agents to disambiguate between these two uses of hidden. Email discussion on this problem does not appear to have yet settled on what mechanism would suffice. See the thread beginning at: http://lists.w3.org/Archives/Public/public-html-a11y/2012Sep/0138
Comment 1 Edward O'Connor 2012-09-21 23:48:50 UTC
EDITOR'S RESPONSE: This is an Editor's Response to your comment. If you are
satisfied with this response, please change the state of this bug to CLOSED. If
you have additional information and would like the editor to reconsider, please
reopen this bug. If you would like to escalate the issue to the full HTML
Working Group, please add the TrackerRequest keyword to this bug, and suggest
title and text for the tracker issue; or you may create a tracker issue
yourself, if you are able to do so. For more details, see this document:
   http://dev.w3.org/html5/decision-policy/decision-policy.html

Status: Rejected
Change Description: No spec change.
Rationale: Fortunately, we already have such machine-detectable
mechanisms. If an author refers to hidden="" content from <img usemap>,
aria-describedby="", etc., then they have established that that
hidden="" content is the second type of hidden content in your list.
Otherwise, tools should presume it is of the first type.
Comment 2 John Foliot 2012-09-22 00:19:29 UTC
(In reply to comment #1)
> 
> Status: Rejected
> Change Description: No spec change.
> Rationale: Fortunately, we already have such machine-detectable
> mechanisms. If an author refers to hidden="" content from <img usemap>,
> aria-describedby="", etc., then they have established that that
> hidden="" content is the second type of hidden content in your list.
> Otherwise, tools should presume it is of the first type.

I think you are missing the distinction of "...it's available for users to read if they perform *some command* to ask to see that content."  

In the case of aria-describedby, the value of that attribute is currently provided without user-intervention via the accessible description in the AAPI. The mechanism for a user to choose to "hear" that content or not does not exist in any current implementation (that I am aware of).
Comment 3 Maciej Stachowiak 2012-09-22 00:42:05 UTC
(In reply to comment #2)
> (In reply to comment #1)
> > 
> > Status: Rejected
> > Change Description: No spec change.
> > Rationale: Fortunately, we already have such machine-detectable
> > mechanisms. If an author refers to hidden="" content from <img usemap>,
> > aria-describedby="", etc., then they have established that that
> > hidden="" content is the second type of hidden content in your list.
> > Otherwise, tools should presume it is of the first type.
> 
> I think you are missing the distinction of "...it's available for users to read
> if they perform *some command* to ask to see that content."  
> 
> In the case of aria-describedby, the value of that attribute is currently
> provided without user-intervention via the accessible description in the AAPI.
> The mechanism for a user to choose to "hear" that content or not does not exist
> in any current implementation (that I am aware of).

It exists in Safari+VoiceOver. aria-label and aria-labeledby are read automatically. aria-description and aria-describedby are read only on demand (you have to hit VO-H). We've always assumed that was supposed to be the distinction between "label" and "description".

Regards,
Maciej
Comment 4 James Craig 2012-09-22 00:52:50 UTC
It looks like the thread has settled somewhat. 

Takeaways: Leif think we should not use <map> as an example. I'm okay with
removing that.
http://lists.w3.org/Archives/Public/public-html-a11y/2012Sep/0222.html

Besides that, I thought we more or less had consensus on the clarification
proposed here: 
http://lists.w3.org/Archives/Public/public-html-a11y/2012Sep/0143.html

Note: Only hidden="" elements that are referenced indirectly by a unique
identifier (ID) reference or valid hash-name reference may have their structure
and content exposed upon user request. Authors desiring to prevent
user-initiated viewing of hidden="" elements should remove identifier (ID) or
hash-name references to the element.
Comment 5 James Craig 2012-09-22 00:56:31 UTC
(In reply to comment #3)
> It exists in Safari+VoiceOver. aria-label and aria-labeledby are read
> automatically. aria-description and aria-describedby are read only on demand
> (you have to hit VO-H). We've always assumed that was supposed to be the
> distinction between "label" and "description".

Minor clarification. There is no @aria-description (Maciej may be thinking of AXDescription?) but the spirit of the comment is correct. @aria-describedby is exposed as AXHelp most of the time, which can be spoken automatically or upon request depending on the user's VoiceOver preferences, so yes, it exists in Safari+VoiceOver.
Comment 6 Edward O'Connor 2012-09-24 23:41:32 UTC
EDITOR'S RESPONSE: This is an Editor's Response to your comment. If you are
satisfied with this response, please change the state of this bug to CLOSED. If
you have additional information and would like the Editor to reconsider, please
reopen this bug. If you would like to escalate the issue to the full HTML
Working Group, please add the TrackerRequest keyword to this bug, and suggest
title and text for the Tracker Issue; or you may create a Tracker Issue
yourself, if you are able to do so. For more details, see this document:

   http://dev.w3.org/html5/decision-policy/decision-policy.html

Status: Accepted
Change Description: https://github.com/w3c/html/commit/4ff4723623375c46a8c1d76af637551a8a3868c8
Rationale: Thanks, James, for the summary of outstanding issues.

I've removed the <map> example per Leif's request, and have added
wording that attempts to clarify matters further. I've also made other
(editorial) changes.